package org.processmining.ptandloggenerator.algorithms;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

import org.processmining.ptandloggenerator.models.NewickTree;
import org.processmining.ptandloggenerator.models.NewickTreeCollection;
import org.processmining.ptandloggenerator.parameters.TreeParameters;

public class CSVIterator {

	private File file;
	private NewickTreeCollection results;
	private TreeFactory factory = null;

	public CSVIterator(String path) {
		file = new File(path);
		results = new NewickTreeCollection();
		factory = new TreeFactory();
		try {
			iterate();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private void iterate() throws IOException {

		String line;
		BufferedReader br = new BufferedReader(new FileReader(file));
		br.readLine();
		TreeParameters parameters;

		while ((line = br.readLine()) != null) {
			parameters = new TreeParameters(line);

			for (int i = 0; i < parameters.getNoTrees(); i++) {
				results.addNewickTree(new NewickTree(
						factory.createTree(parameters.getPatternProbabilities())));
				factory.cleanupInterpreter();
			}
		}
		br.close();
	}

	public NewickTreeCollection getNewickTrees() {
		return results;
	}
}
