package org.processmining.ptandloggenerator.algorithms;

import org.processmining.ptandloggenerator.interfaces.logInterface;
import org.python.core.PyInteger;
import org.python.core.PyObject;
import org.python.core.PyString;
import org.python.core.PyStringMap;
import org.python.core.PySystemState;
import org.python.util.PythonInterpreter;

public class LogFactory {

	private PythonInterpreter interpreter;
	private PyObject jyLogClass;

	public LogFactory() {

		if (interpreter == null) {
			PythonInterpreter.initialize(System.getProperties(), null, new String[] {});
			interpreter = new PythonInterpreter(new PyStringMap(), new PySystemState());
		}
		initializeInterpreter();
	}

	private void initializeInterpreter() {
		interpreter.exec("from simulateTree import LogSimulator");
		jyLogClass = interpreter.get("LogSimulator");
	}

	public logInterface createLog(String newickTree, int numberOfTraces) {
		PyObject caseObj = jyLogClass.__call__(new PyString(newickTree),new PyInteger(numberOfTraces));
		return (logInterface) caseObj.__tojava__(logInterface.class);
	}

	public void cleanupInterpreter() {
		interpreter.cleanup();
	}
}
