package org.processmining.ptandloggenerator.dialogs;

import javax.swing.JComponent;
import javax.swing.JFormattedTextField;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;

import com.fluxicon.slickerbox.colors.SlickerColors;
import com.fluxicon.slickerbox.factory.SlickerFactory;

import info.clearthought.layout.TableLayout;

public class logSettings {

	int numberOfCases;

	/** Spinner for the number of cases to generate */
	JSpinner spinNoCases;
	
	


	/**
	 * Initialize user interface
	 */
	public JComponent initComponents() {
		//Factory to create ProM swing components
		SlickerFactory factory = SlickerFactory.instance();

		//Setting the Panel
		JPanel panel = factory.createRoundedPanel(20, SlickerColors.COLOR_BG_1);
		panel.setLayout(new TableLayout(new double[][] { { 50, 50, 50, 50, 50, 50, 50, 50, 50 },
				{ 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30 } }));

		//ESCAPING THRESHOLD SPINNER-------------------------------------------
		int currentNoCases = 100;
		int minNoCases = new Integer(1);
		int maxNoCases = new Integer(Integer.MAX_VALUE);
		int stepNoCases = new Integer(1);
		//creating the number spinner model
		SpinnerNumberModel modelNoCases = new SpinnerNumberModel(currentNoCases, minNoCases, maxNoCases, stepNoCases);
		//creating the number spinner
		spinNoCases = new JSpinner(modelNoCases);
		JFormattedTextField tfNoCases = ((JSpinner.DefaultEditor) spinNoCases.getEditor()).getTextField();
		tfNoCases.setBackground(SlickerColors.COLOR_BG_3);
		tfNoCases.setForeground(SlickerColors.COLOR_FG);
		spinNoCases.setToolTipText("Specify the number of traces each of the generated event logs will contain");
		//Add
		panel.add(factory.createLabel("<html><h2>The number of traces to generate</h2></html>"), "0, 0, 5, 0");
		panel.add(factory.createLabel("The simulator will produce one event log for each input model!"), "0, 1, 8, 1");
		panel.add(spinNoCases, "0, 2, 1, 2");
		panel.add(factory.createLabel("  Number of cases"), "2, 2, 3, 2");

		return panel;

	}
	
	public void setNoCases(){
		numberOfCases = (int) spinNoCases.getValue();
	}
	
	public int getNoCases(){
		return numberOfCases;
	}

}
