package org.processmining.ptandloggenerator.dialogs;

import java.math.BigDecimal;
import java.math.RoundingMode;

import javax.swing.JComponent;
import javax.swing.JFormattedTextField;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;

import com.fluxicon.slickerbox.colors.SlickerColors;
import com.fluxicon.slickerbox.factory.SlickerFactory;

import info.clearthought.layout.TableLayout;

public class logSettingsNoise {
	int numberOfCases;
	BigDecimal noisePercentage;

	/** Spinner for the number of cases to generate */
	JSpinner spinNoCases;
	/** Spinner for the noise percentage in the log */
	JSpinner spinNoisePercentage;
	

	/**
	 * Initialize user interface
	 */
	public JComponent initComponents() {
		//Factory to create ProM swing components
		SlickerFactory factory = SlickerFactory.instance();

		//Setting the Panel
		JPanel panel = factory.createRoundedPanel(20, SlickerColors.COLOR_BG_1);
		panel.setLayout(new TableLayout(new double[][] { { 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50 },
				{ 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30 } }));

		//NO CASES SPINNER-------------------------------------------
		int currentNoCases = 100;
		int minNoCases = new Integer(1);
		int maxNoCases = new Integer(Integer.MAX_VALUE);
		int stepNoCases = new Integer(1);
		//creating the number spinner model
		SpinnerNumberModel modelNoCases = new SpinnerNumberModel(currentNoCases, minNoCases, maxNoCases, stepNoCases);
		//creating the number spinner
		spinNoCases = new JSpinner(modelNoCases);
		JFormattedTextField tfNoCases = ((JSpinner.DefaultEditor) spinNoCases.getEditor()).getTextField();
		tfNoCases.setBackground(SlickerColors.COLOR_BG_3);
		tfNoCases.setForeground(SlickerColors.COLOR_FG);
		spinNoCases.setToolTipText("Specify the number of traces each of the generated event logs will contain");
		//Add
		panel.add(factory.createLabel("<html><h2>The number of traces to generate</h2></html>"), "0, 0, 5, 0");
		panel.add(factory.createLabel("The simulator will produce one event log for each input model!"), "0, 1, 8, 1");
		panel.add(spinNoCases, "0, 2, 1, 2");
		panel.add(factory.createLabel("  Number of cases"), "2, 2, 3, 2");
		
		//NOISE PROBABILITY SPINNER-------------------------------------------
		double defaultNoisePercentage = 0.0;
		double minNoisePercentage = 0.0;
		double maxNoisePercentage = 1.0;
		double stepNoisePercentage = 0.05;
		//creating the number spinner model
		SpinnerNumberModel modelNoisePercentage = new SpinnerNumberModel(defaultNoisePercentage, minNoisePercentage, maxNoisePercentage, stepNoisePercentage);
		//creating the number spinner
		spinNoisePercentage = new JSpinner(modelNoisePercentage);
		JFormattedTextField tfNoisePercentage = ((JSpinner.DefaultEditor) spinNoisePercentage.getEditor()).getTextField();
		tfNoisePercentage.setBackground(SlickerColors.COLOR_BG_3);
		tfNoisePercentage.setForeground(SlickerColors.COLOR_FG);
		spinNoisePercentage.setToolTipText("Specify the percentage of traces that will contain noise");
		//Add
		panel.add(factory.createLabel("<html><h2>The percentage of noise</h2></html>"), "0, 4, 5, 4");
		panel.add(factory.createLabel("The noise generator will mix noise types: remove head, remove body, remove tail, swap task"), "0, 5, 10, 5");
		panel.add(factory.createLabel("and remove task. All types have the same probability of been selected."), "0, 6, 10, 6");
		panel.add(spinNoisePercentage, "0, 7, 1, 7");
		panel.add(factory.createLabel("  Percentage of noise"), "2, 7, 4, 7");

		return panel;

	}
	
	public void setNoCases(){
		numberOfCases = (int) spinNoCases.getValue();
	}
	
	public int getNoCases(){
		return numberOfCases;
	}
	
	public void setNoisePercentage(){
		noisePercentage = new BigDecimal((double) spinNoisePercentage.getValue()).setScale(2, RoundingMode.HALF_UP);
	}
	
	public BigDecimal getNoisePercentage(){
		return noisePercentage;
	}

}
