package org.processmining.ptandloggenerator.dialogs;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.math.BigDecimal;
import java.math.RoundingMode;

import javax.swing.AbstractButton;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JFormattedTextField;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;

import com.fluxicon.slickerbox.colors.SlickerColors;
import com.fluxicon.slickerbox.factory.SlickerFactory;

import info.clearthought.layout.TableLayout;

public class treeSettings {
	
	/*
	 * settings object used for wizard to generate process trees (GenerateTreeUI plugin)
	 */
	
	int mode;
	int min;
	int max;
	int numberOfTrees;
	String unfold;
	int numberOfIterations;
	BigDecimal probSequence;
	BigDecimal probChoice;
	BigDecimal probParallel;
	BigDecimal probLoop;
	BigDecimal probOr;
	BigDecimal probSilent;
	BigDecimal probDuplicate;
	BigDecimal probLTDependencies;
	BigDecimal infrequent;
	
	JSpinner actMode;
	
	JSpinner actMin;
	
	JSpinner actMax;
	
	JSpinner noTrees;
	
	JSpinner probSeq;
	
	JSpinner probCho;
	
	JSpinner probPar;
	
	JSpinner probLo;
	
	JSpinner probO;
	
	JSpinner probSil;
	
	JSpinner probDupl;
	
	JSpinner probLTDep;
	
	JSpinner probInfreq;
	
	JCheckBox unfoldLoops;
	
	JSpinner loopIterations;
	
	public JComponent initComponents() {
		//Factory to create ProM swing components
		SlickerFactory factory = SlickerFactory.instance();

		//Setting the Panel
		JPanel panel = factory.createRoundedPanel(20, SlickerColors.COLOR_BG_1);
		panel.setLayout(new TableLayout(new double[][] { { 50, 50, 50, 50, 50, 50, 50, 50, 50 ,50, 50, 50, 50},
				{ 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30 } }));
		
		
		//NUMBER OF ACTIVITIES SPINNER-------------------------------------------
		int currentModeActivities = 20;
		int currentMinActivities = 10;
		int currentMaxActivities = 30;
		int minNoActivities = new Integer(1);
		int maxNoActivities = new Integer(Integer.MAX_VALUE);
		int stepNoActivities = new Integer(1);
		//creating the number spinner model
		//mode
		SpinnerNumberModel modeAct = new SpinnerNumberModel(currentModeActivities, minNoActivities, 
				maxNoActivities, stepNoActivities);
		//min
		SpinnerNumberModel minAct = new SpinnerNumberModel(currentMinActivities, minNoActivities, 
				maxNoActivities, stepNoActivities);
		//max
		SpinnerNumberModel maxAct = new SpinnerNumberModel(currentMaxActivities, minNoActivities, 
				maxNoActivities, stepNoActivities);
		
		//creating the min spinner
		actMin = new JSpinner(minAct);
		JFormattedTextField tfactMin = ((JSpinner.DefaultEditor) actMin.getEditor()).getTextField();
		tfactMin.setBackground(SlickerColors.COLOR_BG_3);
		tfactMin.setForeground(SlickerColors.COLOR_FG);
		actMin.setToolTipText("The minimum number of activities in the activity distribution");
		//Add
		panel.add(factory.createLabel("<html><h3>Specify the triangular distribution of the number of activities</h3></html>"), "0, 0, 9, 0");
		panel.add(factory.createLabel("  Minimum activities"), "0, 1, 3, 1");
		panel.add(actMin, "4, 1, 5, 1");
		
		//creating the mode spinner
		actMode = new JSpinner(modeAct);
		JFormattedTextField tfActMode = ((JSpinner.DefaultEditor) actMode.getEditor()).getTextField();
		tfActMode.setBackground(SlickerColors.COLOR_BG_3);
		tfActMode.setForeground(SlickerColors.COLOR_FG);
		actMode.setToolTipText("The number of activities that appears most often in the activity distribution");
		//Add
		panel.add(factory.createLabel("  Mode activities"), "0, 2, 3, 2");
		panel.add(actMode, "4, 2, 5, 2");
		
		//creating the max spinner
		actMax = new JSpinner(maxAct);
		JFormattedTextField tfactMax = ((JSpinner.DefaultEditor) actMax.getEditor()).getTextField();
		tfactMax.setBackground(SlickerColors.COLOR_BG_3);
		tfactMax.setForeground(SlickerColors.COLOR_FG);
		actMax.setToolTipText("The maximum number of activities in the activity distribution");
		//Add
		panel.add(factory.createLabel("  Maximum activities"), "0, 3, 3, 3");
		panel.add(actMax, "4, 3, 5, 3");
		
		
		//NUMBER OF TREES SPINNER-------------------------------------------
		int currentNoTrees = 10;
		int minNoTrees = new Integer(1);
		int maxNoTrees = new Integer(Integer.MAX_VALUE);
		int stepNoTrees = new Integer(1);
		//creating the number spinner model
		SpinnerNumberModel TreesSpin = new SpinnerNumberModel(currentNoTrees, minNoTrees, 
				maxNoTrees, stepNoTrees);
		//creating the number of trees spinner
		noTrees = new JSpinner(TreesSpin);
		JFormattedTextField tfactTrees = ((JSpinner.DefaultEditor) noTrees.getEditor()).getTextField();
		tfactTrees.setBackground(SlickerColors.COLOR_BG_3);
		tfactTrees.setForeground(SlickerColors.COLOR_FG);
		noTrees.setToolTipText("The number of trees that will be generated from the population (= sample size)");
		//Add
		panel.add(factory.createLabel("<html><h3>The number of trees to generate</h3></html>"), "0, 5, 9, 5");
		panel.add(factory.createLabel("  Number of trees"), "0, 6, 3, 6");
		panel.add(noTrees, "4, 6, 5, 6");
		
		
		//PROBABILITIES OPERATORS SPINNER-------------------------------------------
		double currentProb = 0.0;
		double minProb = 0.0;
		double maxProb = 1.0;
		double stepProb = 0.05;
		//creating the probabilities spinner model
		SpinnerNumberModel SpinSequence = new SpinnerNumberModel(currentProb, minProb, 
				maxProb, stepProb);
		SpinnerNumberModel SpinChoice = new SpinnerNumberModel(currentProb, minProb, 
				maxProb, stepProb);
		SpinnerNumberModel SpinParallel = new SpinnerNumberModel(currentProb, minProb, 
				maxProb, stepProb);
		SpinnerNumberModel SpinLoop = new SpinnerNumberModel(currentProb, minProb, 
				maxProb, stepProb);
		SpinnerNumberModel SpinOr = new SpinnerNumberModel(currentProb, minProb, 
				maxProb, stepProb);
		
		//creating the sequence spinner
		probSeq = new JSpinner(SpinSequence);
		JFormattedTextField tfSequence = ((JSpinner.DefaultEditor) probSeq.getEditor()).getTextField();
		tfSequence.setBackground(SlickerColors.COLOR_BG_3);
		tfSequence.setForeground(SlickerColors.COLOR_FG);
		probSeq.setToolTipText("The probability of adding a sequence operator to the tree");
		//Add
		panel.add(factory.createLabel("<html><h3>The probabilities for the process tree operators (sum must be equal to 1!)</h3></html>"),
				"0, 8, 11, 8");
		panel.add(factory.createLabel("  Probability sequence"), "0, 9, 3, 9");
		panel.add(probSeq, "4, 9, 5, 9");
		
		//creating the choice spinner
		probCho = new JSpinner(SpinChoice);
		JFormattedTextField tfChoice = ((JSpinner.DefaultEditor) probCho.getEditor()).getTextField();
		tfChoice.setBackground(SlickerColors.COLOR_BG_3);
		tfChoice.setForeground(SlickerColors.COLOR_FG);
		probCho.setToolTipText("The probability of adding a choice operator to the tree");
		//Add
		panel.add(factory.createLabel("  Probability choice"), "7, 9, 10, 9");
		panel.add(probCho, "11, 9, 12, 9");
		
		//creating the parallel spinner
		probPar = new JSpinner(SpinParallel);
		JFormattedTextField tfParallel = ((JSpinner.DefaultEditor) probPar.getEditor()).getTextField();
		tfParallel.setBackground(SlickerColors.COLOR_BG_3);
		tfParallel.setForeground(SlickerColors.COLOR_FG);
		probPar.setToolTipText("The probability of adding a parallel operator to the tree");
		//Add
		panel.add(factory.createLabel("  Probability parallel"), "0, 10, 3, 10");
		panel.add(probPar, "4, 10, 5, 10");
		
		//creating the loop spinner
		probLo = new JSpinner(SpinLoop);
		JFormattedTextField tfLoop = ((JSpinner.DefaultEditor) probLo.getEditor()).getTextField();
		tfLoop.setBackground(SlickerColors.COLOR_BG_3);
		tfLoop.setForeground(SlickerColors.COLOR_FG);
		probLo.setToolTipText("The probability of adding a loop operator to the tree");
		//Add
		panel.add(factory.createLabel("  Probability loop"), "7, 10, 10, 10");
		panel.add(probLo, "11, 10, 12, 10");
		
		//creating the or spinner
		probO = new JSpinner(SpinOr);
		JFormattedTextField tfOr = ((JSpinner.DefaultEditor) probO.getEditor()).getTextField();
		tfOr.setBackground(SlickerColors.COLOR_BG_3);
		tfOr.setForeground(SlickerColors.COLOR_FG);
		probO.setToolTipText("The probability of adding an or operator to the tree");
		//Add
		panel.add(factory.createLabel("  Probability or"), "0, 11, 3, 11");
		panel.add(probO, "4, 11, 5, 11");
		
		
		//PROBABILITIES OTHER CONSTUCTS SPINNER-------------------------------------------
		double maxDupl = 0.5;
		//creating the probabilities spinner model
		SpinnerNumberModel SpinSilent = new SpinnerNumberModel(currentProb, minProb, 
				maxProb, stepProb);
		SpinnerNumberModel SpinDuplicate = new SpinnerNumberModel(currentProb, minProb, 
				maxDupl, stepProb);
		SpinnerNumberModel SpinLTDependencies = new SpinnerNumberModel(currentProb, minProb, 
				maxProb, stepProb);
		SpinnerNumberModel SpinInfrequent = new SpinnerNumberModel(currentProb, minProb, 
				maxProb, stepProb);
		
		//creating the silent spinner
		probSil = new JSpinner(SpinSilent);
		JFormattedTextField tfSilent = ((JSpinner.DefaultEditor) probSil.getEditor()).getTextField();
		tfSilent.setBackground(SlickerColors.COLOR_BG_3);
		tfSilent.setForeground(SlickerColors.COLOR_FG);
		probSil.setToolTipText("The probability of a silent activity under a choice or loop operator");
		//Add
		panel.add(factory.createLabel("<html><h3>The probabilities for the additional constructs</h3></html>"), "0, 13, 9, 13");
		panel.add(factory.createLabel("  Probability silent activities"), "0, 14, 3, 14");
		panel.add(probSil, "4, 14, 5, 14");
		
		//creating the duplicate spinner
		probDupl = new JSpinner(SpinDuplicate);
		JFormattedTextField tfDuplicate = ((JSpinner.DefaultEditor) probDupl.getEditor()).getTextField();
		tfDuplicate.setBackground(SlickerColors.COLOR_BG_3);
		tfDuplicate.setForeground(SlickerColors.COLOR_FG);
		probDupl.setToolTipText("The probability of having duplicate activities in the tree");
		//Add
		panel.add(factory.createLabel("  Probability duplicate activities"), "7, 14, 10, 14");
		panel.add(probDupl, "11, 14, 12, 14");
		
		//creating the long-term dependencies spinner
		probLTDep = new JSpinner(SpinLTDependencies);
		JFormattedTextField tfLTDependencies = ((JSpinner.DefaultEditor) probLTDep.getEditor()).getTextField();
		tfLTDependencies.setBackground(SlickerColors.COLOR_BG_3);
		tfLTDependencies.setForeground(SlickerColors.COLOR_FG);
		probLTDep.setToolTipText("The probability of adding a dependency between two choices under a sequence");
		//Add
		panel.add(factory.createLabel("  Probability long-term dependency"), "0, 15, 4, 15");
		panel.add(probLTDep, "4, 15, 5, 15");
		
		//add check box for unfolding of loops
		unfoldLoops = factory.createCheckBox("Unfold loops?", false);
		unfoldLoops.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent actionEvent) {
				AbstractButton abstractButton = (AbstractButton)actionEvent.getSource();
		        loopIterations.setEnabled(abstractButton.getModel().isSelected());
			}
		});
		panel.add(unfoldLoops, "7, 15, 8, 15");
		
		//add spinner for maximum number of iterations
		int currentNoIterations = new Integer(1);
		int minIterations = new Integer(1);
		int maxIterations = new Integer(Integer.MAX_VALUE);
		int stepNoIterations = new Integer(1);
		SpinnerNumberModel SpinIterations = new SpinnerNumberModel(currentNoIterations, minIterations, maxIterations, stepNoIterations);
		loopIterations = new JSpinner(SpinIterations);
		JFormattedTextField tfLoopIterations = ((JSpinner.DefaultEditor) loopIterations.getEditor()).getTextField();
		tfLoopIterations.setBackground(SlickerColors.COLOR_BG_3);
		tfLoopIterations.setForeground(SlickerColors.COLOR_FG);
		loopIterations.setToolTipText("The number of iterations of the loop that will be unfolded");
		//Add
		panel.add(factory.createLabel("  Iterations"), "9, 15, 10, 15");
		panel.add(loopIterations, "11, 15, 12, 15");
		
		//INFREQUENT PATHS-------------------------------------------
		probInfreq = new JSpinner(SpinInfrequent);
		panel.add(factory.createLabel("<html><h3>Set if the process trees will contain infrequent paths</h3></html>"),
				"0, 17, 9, 17");
		JFormattedTextField tfInfrequent = ((JSpinner.DefaultEditor) probInfreq.getEditor()).getTextField();
		tfInfrequent.setBackground(SlickerColors.COLOR_BG_3);
		tfInfrequent.setForeground(SlickerColors.COLOR_FG);
		probInfreq.setToolTipText("The probability of making imbalanced branching probabilities in choices");
		panel.add(factory.createLabel("  Probability infrequent paths"), "0, 18, 4, 18");
		panel.add(probInfreq, "4, 18, 5, 18");
		
		return panel;
	}
	
	public void setModeAct(){
		mode = (int) actMode.getValue();
	}
	
	public int getModeAct(){
		return mode;
	}
	
	public void setMinAct(){
		min = (int) actMin.getValue();
	}
	
	public int getMinAct(){
		return min;
	}
	
	public void setMaxAct(){
		max = (int) actMax.getValue();
	}
	
	public int getMaxAct(){
		return max;
	}
	
	public void setNoTrees(){
		numberOfTrees = (int) noTrees.getValue();
	}
	
	public int getNoTrees(){
		return numberOfTrees;
	}
	
	public void setProbSeq(){
		probSequence = new BigDecimal((double) probSeq.getValue()).setScale(2, RoundingMode.HALF_UP);
	}
	
	public BigDecimal getProbSeq(){
		return probSequence;
	}
	
	public void setProbCho(){
		probChoice = new BigDecimal((double) probCho.getValue()).setScale(2, RoundingMode.HALF_UP);
	}
	
	public BigDecimal getProbCho(){
		return probChoice;
	}
	
	public void setProbPar(){
		probParallel = new BigDecimal((double) probPar.getValue()).setScale(2, RoundingMode.HALF_UP);
	}
	
	public BigDecimal getProbPar(){
		return probParallel;
	}
	
	public void setProbLoop(){
		probLoop = new BigDecimal((double) probLo.getValue()).setScale(2, RoundingMode.HALF_UP);
	}
	
	public BigDecimal getProbLoop(){
		return probLoop;
	}
	
	public void setProbOr(){
		probOr = new BigDecimal((double) probO.getValue()).setScale(2, RoundingMode.HALF_UP);
	}
	
	public BigDecimal getProbOr(){
		return probOr;
	}
	
	public void setProbSilent(){
		probSilent = new BigDecimal((double) probSil.getValue()).setScale(2, RoundingMode.HALF_UP);
	}
	
	public BigDecimal getProbSilent(){
		return probSilent;
	}
	
	public void setProbDuplicate(){
		probDuplicate = new BigDecimal((double) probDupl.getValue()).setScale(2, RoundingMode.HALF_UP);
	}
	
	public BigDecimal getProbDuplicate(){
		return probDuplicate;
	}
	
	public void setProbLTDependencies(){
		probLTDependencies = new BigDecimal((double) probLTDep.getValue()).setScale(2, RoundingMode.HALF_UP);
	}
	
	public BigDecimal getProbLTDependencies(){
		return probLTDependencies;
	}
	
	public void setProbInfrequentPaths(){
		infrequent = new BigDecimal((double) probInfreq.getValue()).setScale(2, RoundingMode.HALF_UP);;
	}
	
	public BigDecimal getProbInfrequentPaths(){
		return infrequent;
	}
	
	public void setUnfoldLoops(){
		if (unfoldLoops.isSelected()) {
			unfold = "1";
		}
		else
			unfold = "0";
	}
	
	public String getUnfoldLoops(){
		return unfold;
	}
	
	public void setLoopIterations(){
		numberOfIterations = (int) loopIterations.getValue();
	}
	
	public int getLoopIterations(){
		return numberOfIterations;
	}
	
	public void setAllSettings(){
		setMinAct();
		setModeAct();
		setMaxAct();
		setProbSeq();
		setProbCho();
		setProbPar();
		setProbLoop();
		setProbOr();
		setProbSilent();
		setProbDuplicate();
		setProbLTDependencies();
		setProbInfrequentPaths();
		setNoTrees();
		setUnfoldLoops();
		setLoopIterations();
	}
	
	public boolean checkProbabilities(){
		BigDecimal sum = probSequence.add(probChoice.add(probParallel).add(probLoop).add(probOr)).setScale(2, RoundingMode.HALF_UP);
		//System.out.println(sum.toString());
		int outcome = sum.compareTo(new BigDecimal(1.0));
		if (outcome == 0)
			return true;
		else
			return false;
	}

}
