package org.processmining.ptandloggenerator.models;

import java.util.ArrayList;
import java.util.List;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.factory.XFactory;
import org.deckfour.xes.factory.XFactoryBufferedImpl;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XLog;
import org.python.core.PyDictionary;
import org.python.core.PyList;

public class CaseCollection {
	
	/**
	 * object represents a log as a list of traces (CaseTrace)
	 */

	List<Case> objectList;
	
	public CaseCollection(PyList input) {
		objectList = new ArrayList<Case>();
		int count = input.__len__();
		for (int i = 0; i < count; i++) {
			PyList case_i = (PyList) input.__getitem__(i);
			PyList trace = (PyList) case_i.__getitem__(0);
			PyDictionary attributes = (PyDictionary) case_i.__getitem__(1);
			objectList.add(new Case(trace, attributes, i));
		}		
	}
	
	public XLog getXLog() {

		XFactory factory = new XFactoryBufferedImpl();

		XAttributeMap logMap = factory.createAttributeMap();
		XAttribute id = factory.createAttributeLiteral("concept:name", "Log", XConceptExtension.instance());
		logMap.put(id.getKey(), id);
		
		XLog result = factory.createLog(logMap);
		
		for (Case case_i : objectList) {
			result.add(case_i.getCase());
		}
		return result;

	}
}
