package org.processmining.ptandloggenerator.models;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.factory.XFactory;
import org.deckfour.xes.factory.XFactoryBufferedImpl;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XTrace;
import org.python.core.PyList;
import org.python.core.PyObject;

public class CaseTrace implements Comparable<CaseTrace>{

	private XTrace trace;

	/**
	 * Object represents a trace as a list of activities (strings)
	 * 
	 * @param trace_input
	 */

	public CaseTrace(PyList trace_input, int index) {

		XFactory factory = new XFactoryBufferedImpl();

		XAttributeMap traceMap = factory.createAttributeMap();
		XAttribute id = factory.createAttributeLiteral("concept:name", Integer.toString(index+1),
				XConceptExtension.instance());
		traceMap.put(id.getKey(), id);

		trace = factory.createTrace(traceMap);

		int count = trace_input.__len__();

		for (int i = 0; i < count; i++) {
			PyObject act = trace_input.__getitem__(i);
			String newact = act.asString();

			XAttributeMap attMap = factory.createAttributeMap();
			XAttribute nameAttribute = factory.createAttributeLiteral("concept:name", newact,
					XConceptExtension.instance());
			attMap.put(nameAttribute.getKey(), nameAttribute);
			XEvent event = factory.createEvent(attMap);
			trace.add(event);
		}
	}

	public XTrace getCaseTrace() {
		return trace;
	}


	public int compareTo(CaseTrace o) {
		XTrace newTrace = o.getCaseTrace();
		
		if(newTrace.size() != trace.size())
			return 1;
		else{
			//check trace attributes
			
			//check events
			for(int i = 0 ; i < trace.size() ; i++){
				XAttributeMap newMap = newTrace.get(i).getAttributes();
				XAttributeMap map = trace.get(i).getAttributes();
				
				for(XAttribute attribute : map.values()){
					if(!newMap.containsKey(attribute.getKey()))
						return 1;
					else{
						if(newMap.get(attribute.getKey()).compareTo(map.get(attribute.getKey())) != 0)
							return 1;
					}
				}
			}
		}		
		return 0;
	}
}

























