package org.processmining.ptandloggenerator.models;

import java.util.ArrayList;
import java.util.List;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.factory.XFactory;
import org.deckfour.xes.factory.XFactoryBufferedImpl;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XLog;
import org.python.core.PyList;

public class CaseTraceCollection {

	/**
	 * object represents a log as a list of traces (CaseTrace)
	 */

	List<CaseTrace> objectList;

	public CaseTraceCollection(PyList input) {
		objectList = new ArrayList<CaseTrace>();
		
		int count = input.__len__();

		for (int i = 0; i < count; i++) {
			PyList trace = (PyList) input.__getitem__(i);
			objectList.add(new CaseTrace(trace, i));
		}		
	}

	public XLog getXLog() {

		XFactory factory = new XFactoryBufferedImpl();

		XAttributeMap logMap = factory.createAttributeMap();
		XAttribute id = factory.createAttributeLiteral("concept:name", "Log", XConceptExtension.instance());
		logMap.put(id.getKey(), id);
		
		XLog result = factory.createLog(logMap);
		
		for (CaseTrace trace : objectList) {
			result.add(trace.getCaseTrace());
		}
		return result;

	}

}
