package org.processmining.ptandloggenerator.models;

import org.processmining.ptandloggenerator.interfaces.randomTree;

public class NewickTree {

	private String newickTree;

	/**
	 * constructor that stores the newick tree string in the attribute
	 * 
	 * @param newickString
	 *            contains the output of the python generation of a tree
	 */
	public NewickTree(randomTree tree) {
		newickTree = tree.returnTree();
	}
	
	/**
	 * constructor only to be called for ProcessTree to NewickTree conversion
	 * 
	 * @param treeString
	 */
	
	public NewickTree(String treeString){
		newickTree = treeString;
	}
	

	/**
	 * 
	 * @return the process tree as a newick string
	 */

	public String getTree() {
		return newickTree;
	}

}
