package org.processmining.ptandloggenerator.parsers;

import org.processmining.framework.plugin.PluginContext;
import org.processmining.models.connections.petrinets.behavioral.FinalMarkingConnection;
import org.processmining.models.connections.petrinets.behavioral.InitialMarkingConnection;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.conversion.ProcessTree2Petrinet;
import org.processmining.processtree.conversion.ProcessTree2Petrinet.InvalidProcessTreeException;
import org.processmining.processtree.conversion.ProcessTree2Petrinet.NotYetImplementedException;
import org.processmining.processtree.conversion.ProcessTree2Petrinet.PetrinetWithMarkings;
import org.processmining.ptandloggenerator.models.NewickTree;
import org.processmining.ptandloggenerator.plugins.NewickTreeToProcessTreeConverter;

@SuppressWarnings("deprecation")
public class NewickToPetriNet {
	
	public static Object[] convert(PluginContext context, NewickTree tree) throws NotYetImplementedException, InvalidProcessTreeException {
		NewickTreeToProcessTreeConverter converter = new NewickTreeToProcessTreeConverter();
		ProcessTree processTree = converter.run(context, tree);
		PetrinetWithMarkings pn = ProcessTree2Petrinet.convert(processTree, false);
		context.addConnection(new InitialMarkingConnection(pn.petrinet, pn.initialMarking));
		context.addConnection(new FinalMarkingConnection(pn.petrinet, pn.finalMarking));
		return new Object[] {pn.petrinet, pn.initialMarking, pn.finalMarking};
	}
	
}
