package org.processmining.ptandloggenerator.plugins;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;

import org.processmining.contexts.uitopia.annotations.UIExportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.ptandloggenerator.models.NewickTree;
import org.processmining.ptandloggenerator.models.NewickTreeCollection;

@Plugin(name = "Export Newick Tree Collection", returnLabels = {}, returnTypes = {}, parameterLabels = {
		"Newick Tree Collection", "File" }, userAccessible = true)
@UIExportPlugin(description = "Newick Tree Collection", extension = "nw")
public class ExportNewickTree {
	@PluginVariant(variantLabel = "Export Newick Tree Collection", requiredParameterLabels = { 0, 1 })
	public void exportNewickTreeCollection(PluginContext context, NewickTreeCollection collection, File file) throws IOException {
		
		Writer fileWriter = new FileWriter(file);
		Boolean firstLine = true;
		
		for (NewickTree tree: collection.getNewickTreeList()) {
			if (firstLine)
				firstLine = false;
			else
				fileWriter.write("\n");
			fileWriter.write(tree.getTree());
		}
		fileWriter.close();
	}
}
