package org.processmining.ptandloggenerator.plugins;

import java.util.ArrayList;
import java.util.List;

import org.deckfour.xes.model.XLog;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.ptandloggenerator.algorithms.LogCollectionGenerator;
import org.processmining.ptandloggenerator.models.NewickTree;
import org.processmining.ptandloggenerator.models.NewickTreeCollection;

@Plugin(name = "Generate an Event Log from a Process Tree", parameterLabels = { "Newick Tree Collection",
		"Log Generator Parameters" }, returnLabels = { "Log (XES format)" }, returnTypes = {
				XLog.class }, help = "help text")
public class GenerateLog {

	@PluginVariant(variantLabel = "Generate an Event Log from a Process Tree", requiredParameterLabels = { 0 })
	public XLog run(PluginContext context, NewickTree tree, int numTrainigTraces) {

		NewickTreeCollection collection = new NewickTreeCollection();
		collection.addNewickTree(tree);
		LogCollectionGenerator generator = new LogCollectionGenerator(collection, numTrainigTraces);

		List<XLog> list = new ArrayList<XLog>();
		for (XLog element : generator.getLogs().getXLogCollection())
			list.add(element);
		generator.cleanUp();

		if (!list.isEmpty())
			return list.get(0);
		else
			return null;

	}

}
