package org.processmining.ptandloggenerator.plugins;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;

import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

import org.processmining.contexts.uitopia.annotations.UIImportPlugin;
import org.processmining.framework.abstractplugins.AbstractImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.ptandloggenerator.models.NewickTree;
import org.processmining.ptandloggenerator.models.NewickTreeCollection;

@Plugin(name = "Import Newick tree from newick file", parameterLabels = { "Filename" }, returnLabels = { "Newick Tree Collection" }, returnTypes = { NewickTreeCollection.class })
@UIImportPlugin(description = "NW newick tree files", extensions = { "nw" })
public class ImportNewickTree extends AbstractImportPlugin{
	
	private String tree;
	private NewickTreeCollection collection;
	
	protected FileFilter getFileFilter() {
		return new FileNameExtensionFilter("Newick Tree files", "nw");
	}

	protected Object importFromStream(PluginContext context, InputStream input, String filename, long fileSizeInBytes)
			throws Exception {
		collection = new NewickTreeCollection();
		BufferedReader br = new BufferedReader(new InputStreamReader(input));
		String line;
		while ((line = br.readLine()) != null) {
			tree = line;
			collection.addNewickTree(new NewickTree(tree));
		}
		br.close();
		return collection; 
	}

}
