package org.processmining.ptandloggenerator.plugins;

import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.processtree.arrays.ProcessTreeArray;
import org.processmining.processtree.arrays.impl.ProcessTreeArrayImpl;
import org.processmining.ptandloggenerator.models.NewickTree;
import org.processmining.ptandloggenerator.models.NewickTreeCollection;

@Plugin(name = "Convert Newick Tree Collection to Process Tree List", parameterLabels = {
		"CSV file with parameters" }, returnLabels = { "Process Tree" }, returnTypes = {
				ProcessTreeArray.class }, help = "help text")
public class NewickTreeCollectionToProcessTreeListConverter {

	@UITopiaVariant(affiliation = "Hasselt University", author = "Toon Jouck", email = "toon.jouck@uhasselt.be")
	@PluginVariant(variantLabel = "Convert a Newick Tree Collection to Process Tree Collection", requiredParameterLabels = {
			0 })
	public ProcessTreeArray run(PluginContext context, NewickTreeCollection collection) {

		ProcessTreeArray array = new ProcessTreeArrayImpl();
		NewickTreeToProcessTreeConverter converter = new NewickTreeToProcessTreeConverter();
		
		for (NewickTree tree : collection.getNewickTreeList())
			array.addElement(converter.run(context, tree));

		return array;
	}
}
