package org.processmining.ptandloggenerator.plugins;

import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.processtree.ProcessTree;
import org.processmining.ptandloggenerator.models.NewickTree;
import org.processmining.ptandloggenerator.parsers.NewickTreeToProcessTree;

@Plugin(name = "Convert Newick Tree to Process Tree", parameterLabels = { "CSV file with parameters" }, returnLabels = {
		"Process Tree" }, returnTypes = { ProcessTree.class }, help = "help text")
public class NewickTreeToProcessTreeConverter {

	@UITopiaVariant(affiliation = "Hasselt University", author = "Toon Jouck", email = "toon.jouck@uhasselt.be")
	@PluginVariant(variantLabel = "Convert a Newick Tree to Process Tree", requiredParameterLabels = { 0 })
	public ProcessTree run(PluginContext context, NewickTree tree) {
		NewickTreeToProcessTree converter = new NewickTreeToProcessTree(tree);
		return converter.getProcessTree();
	}

	
}
