package org.processmining.ptandloggenerator.plugins;

import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.processtree.ProcessTree;
import org.processmining.ptandloggenerator.models.NewickTree;
import org.processmining.ptandloggenerator.models.NewickTreeCollection;
import org.processmining.ptandloggenerator.parsers.ProcessTreeToNewickTree;

@Plugin(name = "Convert Process Tree to Newick Tree", parameterLabels = { "Process tree" }, returnLabels = {
		"Newick tree collection" }, returnTypes = { NewickTreeCollection.class }, help = "help text")
public class ProcessTreeToNewickTreeConverter {

	@UITopiaVariant(affiliation = "Hasselt University", author = "Toon Jouck", email = "toon.jouck@uhasselt.be")
	@PluginVariant(variantLabel = "Convert a Process Tree to a Newick Tree", requiredParameterLabels = { 0 })
	public NewickTreeCollection run(PluginContext context, ProcessTree tree) {
		ProcessTreeToNewickTree converter = new ProcessTreeToNewickTree(tree);
		NewickTree newickTree = converter.getNewickTree();
		NewickTreeCollection results = new NewickTreeCollection();
		results.addNewickTree(newickTree);
		return results;
	}
}
