package org.processmining.ptandloggenerator.plugins;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.ptandloggenerator.models.LogCollection;

@Plugin(name = "Unpack Log Collection", parameterLabels = { "LogCollection" }, returnLabels = {
"Overview" }, returnTypes = { LogCollection.class })

public class UnPackXLogCollection {
	
	@UITopiaVariant(affiliation = "Hasselt University", author = "Toon Jouck", email = "toon.jouck@uhasselt.be")
	@PluginVariant(variantLabel = "Unpack log collection", requiredParameterLabels = { 0 })
	public void unpack(PluginContext context, LogCollection output) {
		int i = 1;
		for (XLog log: output.getXLogCollection()){
			context.getProvidedObjectManager().createProvidedObject("Log " + Integer.toString(i), log, XLog.class , context);
			org.processmining.plugins.utils.ProvidedObjectHelper.setFavorite(context, log);
			i++;
		}
				
	}

}
