package org.processmining.ptandloggenerator.plugins;

import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.arrays.ProcessTreeArray;

@Plugin(name = "Unpack Process Tree Array", parameterLabels = { "ProcessTreeArray" }, returnLabels = {
"Overview" }, returnTypes = { ProcessTreeArray.class })
public class UnpackProcessTreeArray {
	
	@UITopiaVariant(affiliation = "Hasselt University", author = "Toon Jouck", email = "toon.jouck@uhasselt.be")
	@PluginVariant(variantLabel = "Unpack process tree array", requiredParameterLabels = { 0 })
	public ProcessTreeArray unpack(PluginContext context, ProcessTreeArray trees){

		for(int i = 0; i < trees.getSize(); i++){
			ProcessTree tree = trees.getElement(i);
			context.getProvidedObjectManager().createProvidedObject("Tree " + Integer.toString(i+1), tree,
					ProcessTree.class , context);
			org.processmining.plugins.utils.ProvidedObjectHelper.setFavorite(context, tree);
		}
		return trees;
	}

}
