package org.processmining.ptandloggenerator.plugins.data;

import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;

import org.deckfour.xes.model.XLog;
import org.deckfour.xes.out.XesXmlSerializer;
import org.processmining.contexts.uitopia.annotations.UIExportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.ptandloggenerator.models.DataLogCollection;

import com.csvreader.CsvWriter;

@Plugin(name = "Export Data Log Collection", returnLabels = {}, returnTypes = {}, parameterLabels = {
		"Data Log Collection", "File" }, userAccessible = true)
@UIExportPlugin(description = "Data Log Collection", extension = "dlc")
public class ExportDataLogCollection {
	
	@PluginVariant(variantLabel = "Export Data Log Collection to XES files", requiredParameterLabels = { 0, 1 })
	public void exportDataLogCollection(PluginContext context, DataLogCollection collection, File file) throws IOException {
		XesXmlSerializer logSerializer = new XesXmlSerializer();
		Writer fileWriter = new FileWriter(file);
		CsvWriter csvWriter = new CsvWriter(fileWriter, ',');
		int n = 1;
		for (XLog log: collection.getXLogCollection()) {
			String fileName = file.getName();
			File dir = file.getParentFile();
			String prefix = fileName.substring(0, fileName.indexOf("."));
			File netFile = File.createTempFile(prefix + "_" + n + "_", ".xes", dir);
			csvWriter.write(netFile.getName());
			csvWriter.endRecord();
			System.out.println("Exporting XLog to " + netFile.getName());
			FileOutputStream out = new FileOutputStream(netFile);
			logSerializer.serialize(log, out);
			out.close();
			n++;
		}
		csvWriter.close();
	}
}
