package org.processmining.ptandloggenerator.renderers;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.ptandloggenerator.models.DataLogCollection;

@Plugin(name = "Visualize Data Log Collection", parameterLabels = { "DataLogCollection" }, returnLabels = {
"String Representation" }, returnTypes = { JComponent.class })
@Visualizer
public class DataLogCollectionRenderer {
	@PluginVariant(requiredParameterLabels = { 0 })
	public static JComponent visualize(PluginContext context, DataLogCollection output) {
		
		JTextPane pane = new JTextPane();
		
		//Content
		pane.setBorder(BorderFactory.createEmptyBorder());
		pane.setContentType("text/html");
		pane.setEditable(false);
		pane.setCaretPosition(0);

		//Text
		StringBuffer text = new StringBuffer();
		text.append("<html><body bgcolor=\"#888888\" text=\"#111111\">");
		
		//Traces
		text.append("<center><br><table width=\"95%\" border=\"0\" cellspacing=\"10\" cellpadding=\"10\">");
		text.append("<tr><td width=\"100%\" align=\"left\" bgcolor=\"#AAAAAA\">");
		text.append("<font face=\"arial,helvetica,sans-serif\" size=\"+2\" color=\"#111111\">");
		text.append("Overview of Event Logs created");
		text.append("</font><hr noshade width=\"100%\" size=\"1\"><br>");
		
		text.append("<font face=\"arial,helvetica,sans-serif\">");
		text.append("Number of logs generated: ");
		text.append(output.getXLogCollection().size());
		text.append("</font>");
		text.append("<br><br>");
		
		int i = 1;
		for (XLog log: output.getXLogCollection()){
			text.append("<font face=\"arial,helvetica,sans-serif\"><b>");
			text.append("Log " + Integer.toString(i));
			text.append("</b><br>");
			text.append("Number of traces: ");
			text.append(log.size());
			text.append("</font>");
			text.append("<br>");
			text.append("<br>");
			i++;
		}
		text.append("</td></tr>");
		pane.setText(text.toString());
		
		JScrollPane scrollPane = new JScrollPane(pane);
		
		return scrollPane;
	}

}
