package org.processmining.ptandloggenerator.renderers;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.ptandloggenerator.models.NewickTree;
import org.processmining.ptandloggenerator.models.NewickTreeCollection;

@Plugin(name = "Visualize Newick Tree As String", parameterLabels = { "NewickTreeCollection" }, returnLabels = {
		"String Representation" }, returnTypes = { JComponent.class })
@Visualizer
public class NewickTreeRenderer {

	@PluginVariant(requiredParameterLabels = { 0 })
	public static JComponent visualize(PluginContext context, NewickTreeCollection output) {
		
		//Content
		JTextPane pane = new JTextPane();
		pane.setBorder(BorderFactory.createEmptyBorder());
		pane.setContentType("text/html");
		pane.setEditable(false);
		pane.setCaretPosition(0);
		
		//Text
		StringBuffer text = new StringBuffer();
		text.append("<html><body bgcolor=\"#888888\" text=\"#111111\">");
		
		//Traces
		text.append("<center><br><table width=\"95%\" border=\"0\" cellspacing=\"10\" cellpadding=\"10\">");
		text.append("<tr><td width=\"100%\" align=\"left\" bgcolor=\"#AAAAAA\">");
		text.append("<font face=\"arial,helvetica,sans-serif\" size=\"+2\" color=\"#111111\">");
		String fontText = "<font face=\"arial,sans-serif\" size=\"4\">";
		
		if (output.getNewickTreeList().size() > 0){
			text.append("Newick Trees:");
			text.append("</font><hr noshade width=\"100%\" size=\"1\"><br>");
			
			for (NewickTree tree : output.getNewickTreeList()) {
				text.append(tree.getTree());
				text.append("</b><br>");
			}
		}
		else {
			text.append("ERROR:");
			text.append("</font><hr noshade width=\"100%\" size=\"1\"><br>");
			text.append("User did not provide operator probabilities that sum to one!");
			text.append("</b><br>");
		}

		text.append("</td></tr>");
		text.append(fontText + "</b><br>");
		pane.setText(text.toString());
		JScrollPane scrollPane = new JScrollPane(pane);
		
		return scrollPane;
	}

}
